//------------------------------------------------------------------------------
// <auto-generated />
//
// This file was automatically generated by SWIG (http://www.swig.org).
// Version 3.0.12
//
// Do not make changes to this file unless you know what you are doing--modify
// the SWIG interface file instead.
//------------------------------------------------------------------------------

namespace OpenMMNET {

public class State : global::System.IDisposable {
  private global::System.Runtime.InteropServices.HandleRef swigCPtr;
  protected bool swigCMemOwn;

  internal State(global::System.IntPtr cPtr, bool cMemoryOwn) {
    swigCMemOwn = cMemoryOwn;
    swigCPtr = new global::System.Runtime.InteropServices.HandleRef(this, cPtr);
  }

  internal static global::System.Runtime.InteropServices.HandleRef getCPtr(State obj) {
    return (obj == null) ? new global::System.Runtime.InteropServices.HandleRef(null, global::System.IntPtr.Zero) : obj.swigCPtr;
  }

  ~State() {
    Dispose();
  }

  public virtual void Dispose() {
    lock(this) {
      if (swigCPtr.Handle != global::System.IntPtr.Zero) {
        if (swigCMemOwn) {
          swigCMemOwn = false;
          OpenMMSwigPINVOKE.delete_State(swigCPtr);
        }
        swigCPtr = new global::System.Runtime.InteropServices.HandleRef(null, global::System.IntPtr.Zero);
      }
      global::System.GC.SuppressFinalize(this);
    }
  }


	float[] positions;
	float[] velocities;
	float[] forces;

    public float[] GetPositionsAsArray()
	{
		if(positions == null)
		{
			positions = new float[3*getNumParticles()];
			GetVectorAsFloatArray(State.DataType.Positions, positions);
		}
		return positions;
	}

	public float[] GetForcesAsArray()
	{
		if(forces == null)
		{
			forces = new float[3*getNumParticles()];
			GetVectorAsFloatArray(State.DataType.Forces, forces);
		}
		return forces;
	}
 
 
    public float[] GetVelocitiesAsArray()
	{
		if(velocities == null)
		{
			velocities = new float[3*getNumParticles()];
			GetVectorAsFloatArray(State.DataType.Positions, velocities);
		}
		return velocities;
	}


  public State() : this(OpenMMSwigPINVOKE.new_State(), true) {
  }

  public double getTime() {
    double ret = OpenMMSwigPINVOKE.State_getTime(swigCPtr);
    return ret;
  }

  public OpenMMVectorVec3 getPositions() {
    OpenMMVectorVec3 ret = new OpenMMVectorVec3(OpenMMSwigPINVOKE.State_getPositions(swigCPtr), false);
    return ret;
  }

  public OpenMMVectorVec3 getVelocities() {
    OpenMMVectorVec3 ret = new OpenMMVectorVec3(OpenMMSwigPINVOKE.State_getVelocities(swigCPtr), false);
    return ret;
  }

  public OpenMMVectorVec3 getForces() {
    OpenMMVectorVec3 ret = new OpenMMVectorVec3(OpenMMSwigPINVOKE.State_getForces(swigCPtr), false);
    return ret;
  }

  public double getKineticEnergy() {
    double ret = OpenMMSwigPINVOKE.State_getKineticEnergy(swigCPtr);
    return ret;
  }

  public double getPotentialEnergy() {
    double ret = OpenMMSwigPINVOKE.State_getPotentialEnergy(swigCPtr);
    return ret;
  }

  public void getPeriodicBoxVectors(Vec3 a, Vec3 b, Vec3 c) {
    OpenMMSwigPINVOKE.State_getPeriodicBoxVectors(swigCPtr, Vec3.getCPtr(a), Vec3.getCPtr(b), Vec3.getCPtr(c));
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public double getPeriodicBoxVolume() {
    double ret = OpenMMSwigPINVOKE.State_getPeriodicBoxVolume(swigCPtr);
    return ret;
  }

  public SWIGTYPE_p_std__mapT_std__string_double_std__lessT_std__string_t_t getParameters() {
    SWIGTYPE_p_std__mapT_std__string_double_std__lessT_std__string_t_t ret = new SWIGTYPE_p_std__mapT_std__string_double_std__lessT_std__string_t_t(OpenMMSwigPINVOKE.State_getParameters(swigCPtr), false);
    return ret;
  }

  public SWIGTYPE_p_std__mapT_std__string_double_std__lessT_std__string_t_t getEnergyParameterDerivatives() {
    SWIGTYPE_p_std__mapT_std__string_double_std__lessT_std__string_t_t ret = new SWIGTYPE_p_std__mapT_std__string_double_std__lessT_std__string_t_t(OpenMMSwigPINVOKE.State_getEnergyParameterDerivatives(swigCPtr), false);
    return ret;
  }

  public int getDataTypes() {
    int ret = OpenMMSwigPINVOKE.State_getDataTypes(swigCPtr);
    return ret;
  }

  public class StateBuilder : global::System.IDisposable {
    private global::System.Runtime.InteropServices.HandleRef swigCPtr;
    protected bool swigCMemOwn;
  
    internal StateBuilder(global::System.IntPtr cPtr, bool cMemoryOwn) {
      swigCMemOwn = cMemoryOwn;
      swigCPtr = new global::System.Runtime.InteropServices.HandleRef(this, cPtr);
    }
  
    internal static global::System.Runtime.InteropServices.HandleRef getCPtr(StateBuilder obj) {
      return (obj == null) ? new global::System.Runtime.InteropServices.HandleRef(null, global::System.IntPtr.Zero) : obj.swigCPtr;
    }
  
    ~StateBuilder() {
      Dispose();
    }
  
    public virtual void Dispose() {
      lock(this) {
        if (swigCPtr.Handle != global::System.IntPtr.Zero) {
          if (swigCMemOwn) {
            swigCMemOwn = false;
            OpenMMSwigPINVOKE.delete_State_StateBuilder(swigCPtr);
          }
          swigCPtr = new global::System.Runtime.InteropServices.HandleRef(null, global::System.IntPtr.Zero);
        }
        global::System.GC.SuppressFinalize(this);
      }
    }
  
    public StateBuilder(double time) : this(OpenMMSwigPINVOKE.new_State_StateBuilder(time), true) {
    }
  
    public State getState() {
      State ret = new State(OpenMMSwigPINVOKE.State_StateBuilder_getState(swigCPtr), true);
      return ret;
    }
  
    public void setPositions(OpenMMVectorVec3 pos) {
      OpenMMSwigPINVOKE.State_StateBuilder_setPositions(swigCPtr, OpenMMVectorVec3.getCPtr(pos));
      if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
    }
  
    public void setVelocities(OpenMMVectorVec3 vel) {
      OpenMMSwigPINVOKE.State_StateBuilder_setVelocities(swigCPtr, OpenMMVectorVec3.getCPtr(vel));
      if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
    }
  
    public void setForces(OpenMMVectorVec3 force) {
      OpenMMSwigPINVOKE.State_StateBuilder_setForces(swigCPtr, OpenMMVectorVec3.getCPtr(force));
      if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
    }
  
    public void setParameters(SWIGTYPE_p_std__mapT_std__string_double_std__lessT_std__string_t_t arg0) {
      OpenMMSwigPINVOKE.State_StateBuilder_setParameters(swigCPtr, SWIGTYPE_p_std__mapT_std__string_double_std__lessT_std__string_t_t.getCPtr(arg0));
      if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
    }
  
    public void setEnergyParameterDerivatives(SWIGTYPE_p_std__mapT_std__string_double_std__lessT_std__string_t_t arg0) {
      OpenMMSwigPINVOKE.State_StateBuilder_setEnergyParameterDerivatives(swigCPtr, SWIGTYPE_p_std__mapT_std__string_double_std__lessT_std__string_t_t.getCPtr(arg0));
      if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
    }
  
    public void setEnergy(double ke, double pe) {
      OpenMMSwigPINVOKE.State_StateBuilder_setEnergy(swigCPtr, ke, pe);
    }
  
    public void setPeriodicBoxVectors(Vec3 a, Vec3 b, Vec3 c) {
      OpenMMSwigPINVOKE.State_StateBuilder_setPeriodicBoxVectors(swigCPtr, Vec3.getCPtr(a), Vec3.getCPtr(b), Vec3.getCPtr(c));
      if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
    }
  
  }

  public int getNumParticles() {
    int ret = OpenMMSwigPINVOKE.State_getNumParticles(swigCPtr);
    return ret;
  }

  public void GetVectorAsFloatArray(State.DataType type, float[] output) {
    OpenMMSwigPINVOKE.State_GetVectorAsFloatArray(swigCPtr, (int)type, output);
  }

  public enum DataType {
    Positions = 1,
    Velocities = 2,
    Forces = 4,
    Energy = 8,
    Parameters = 16,
    ParameterDerivatives = 32
  }

}

}
